//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "prog.h"
#include "serial_port.h"
#include <fcntl.h>
#include <vcl.h>

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

#define cbOutQueue 256 //rozmiar bufora danych wyjciowych
#define cbInQueue  256 //rozmiar bufora danych wejciowych


TForm1 *Form1;
unsigned char    Buffer_O[cbOutQueue]; // bufor danych wyjciowych
unsigned char    Buffer_I[cbInQueue];  // bufor danych wejciowych
unsigned char znak[4];
int conf_p;  //uchwyt do pliku konfiguracyjnego
AnsiString z_str;
unsigned int il_znak=0;
DWORD   Number_Bytes_Read; // Number Bytes to Read - liczba
DWORD   fdwEvtMask; // informacja o aktualnym stanie transmisji
COMSTAT Stat;       // dodatkowa informacja o zasobach portu
DWORD   Errors;     // reprezentuje typ ewentualnego b-du
HANDLE   hCommDev;   // identyfikator portu
LPCTSTR  lpFileName; // przechowuje nazw portu
DCB      dcb;        // struktura kontroli portu szeregowego
LPCTSTR sbuffer2 = "Error!";
LPCTSTR sbuffer3 = "Port is open";
LPCTSTR sbuffer4 = "Port is not open";
////////////////////////////////////

BOOL __fastcall Write_Comm(HANDLE hCommDev, LPCVOID lpBuffer,
                          DWORD nNumberOfBytesToWrite)
{
   DWORD NumberOfBytesWritten;
   PurgeComm(hCommDev,PURGE_RXCLEAR);
   if (WriteFile(hCommDev, lpBuffer,
       nNumberOfBytesToWrite, &NumberOfBytesWritten, NULL)
       == TRUE)
     {
         return TRUE;
     }
     else
         return false;
}

//-------------------odczyt danych-------------------------
BOOL __fastcall Read_Comm(HANDLE hCommDev, LPVOID lpBuffer,
                      LPDWORD lpNumberOfBytesRead, DWORD Buf_Size)
{
    DWORD nNumberOfBytesToRead;
    ClearCommError(hCommDev, &Errors, &Stat);
    *lpNumberOfBytesRead = 0;
     if (Stat.cbInQue > 0)
     {
       if (Stat.cbInQue > Buf_Size)
           nNumberOfBytesToRead = Buf_Size;
         else
           nNumberOfBytesToRead = Stat.cbInQue;
      }
     return ReadFile(hCommDev, lpBuffer, nNumberOfBytesToRead,
                     lpNumberOfBytesRead, NULL);
}

void __fastcall delay()
{
  for (int i=0;i<100;i++)
  {
   Sleep(3);
   ClearCommError(hCommDev, &Errors, &Stat);
   if ((Stat.cbInQue) > il_znak)
  {
     break;
   }
  }
 }

void __fastcall Wys_zn(char zn)      //wysyla przez port znak
{
  TransmitCommChar(hCommDev, zn);
}

void __fastcall Zamk_port(TObject *Sender)     //Zamyka port szeregowy
{
  CloseHandle(hCommDev);
}

void Ust_port__szer(TObject *Sender) //otwiera port szeregowy
{
  char par2[2];
  int byte;
  conf_p = FileOpen("conf.inf",fmOpenReadWrite);
  byte=FileRead(conf_p,&par2[0],1);
  byte = StrToInt(par2[0]);
  if (byte<9)
    Form2->Port_s->ItemIndex=byte;
  byte=FileRead(conf_p,&par2[0],1);
  par2[0]=NULL;
  byte=FileRead(conf_p,&par2[0],1);
  byte = StrToInt(par2[0]);
  if (byte<4)
    Form2->Port_b->ItemIndex=byte;
  FileClose(conf_p);
  switch (Form2->Port_s->ItemIndex) {
           case 0:
             lpFileName = "COM1";
             break;
           case 1:
             lpFileName = "COM2";
             break;
           case 2:
             lpFileName = "COM3";
             break;
           case 3:
             lpFileName = "COM4";
             break;
           case 4:
             lpFileName = "COM5";
             break;
           case 5:
             lpFileName = "COM6";
             break;
           case 6:
             lpFileName = "COM7";
             break;
           case 7:
             lpFileName = "COM8";
             break;
           default:
             lpFileName = "COM1";
        }
   hCommDev = CreateFile(lpFileName, GENERIC_READ |
                         GENERIC_WRITE, 0, NULL,
                         OPEN_EXISTING, 0, NULL);
  if (hCommDev != INVALID_HANDLE_VALUE)
     // sprawdza, czy port jest otwarty prawidowo
      {
        dcb.DCBlength = sizeof(dcb);
        GetCommState(hCommDev, &dcb);
        switch (Form2->Port_b->ItemIndex) {
           case 0:
             dcb.BaudRate=CBR_38400;
             break;
           case 1:
             dcb.BaudRate=CBR_57600;
             break;
           case 2:
            dcb.BaudRate=CBR_115200;
             break;
           default:
             dcb.BaudRate=CBR_115200;
        }
        dcb.Parity = NOPARITY;        // ustawienie parzystoci
        dcb.StopBits = ONESTOPBIT;     // bity stopu
        dcb.ByteSize = 8;              // bity danych
        //-przykadowe ustawienia flag sterujcych DCB-
        dcb.fParity = TRUE;            // sprawdzanie parzystoci
        dcb.fDtrControl = DTR_CONTROL_DISABLE;
        dcb.fRtsControl = RTS_CONTROL_DISABLE;
        dcb.fOutxCtsFlow = FALSE;
        dcb.fOutxDsrFlow = FALSE;
        dcb.fDsrSensitivity = FALSE;
        dcb.fAbortOnError = FALSE;
        dcb.fOutX = FALSE;
        dcb.fInX = FALSE;
        dcb.fErrorChar = FALSE;
        dcb.fNull = FALSE;
        SetCommState(hCommDev, &dcb);
        GetCommMask(hCommDev, &fdwEvtMask);
        SetCommMask(hCommDev, EV_TXEMPTY);
      }
      else
        {
        switch ((int)hCommDev)
          {
          case IE_BADID:
           MessageBox(NULL, sbuffer3, sbuffer2, MB_OK);
            break;
           };
         }
           if ((hCommDev != INVALID_HANDLE_VALUE) && (hCommDev > 0))
       {
     }

}

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Exit1Click(TObject *Sender)
{
Application->Terminate();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Serialport1Click(TObject *Sender)
{
   Form2->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
    char par[]="0\n";
    if (!FileExists("conf.inf")){
    conf_p = FileCreate("conf.inf",O_CREAT | O_TEXT);
    FileWrite(conf_p, par, strlen(par));
    StrCopy(par,"2\n");
    FileWrite(conf_p, par, strlen(par));
    FileClose(conf_p);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormShow(TObject *Sender)
{
  char par2[2];
  int byte;
  conf_p = FileOpen("conf.inf",fmOpenReadWrite);
  FileSeek(conf_p,4,0);
  byte = FileRead(conf_p,&par2[0],1);
  FileClose(conf_p);
  Ust_port__szer(Form1);
  Form1->Timer1->Enabled = true;


}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
  Form1->Timer1->Enabled = false;
  Zamk_port(this);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
  FlushFileBuffers(hCommDev);
  znak[0]= 't';
  strcpy(Buffer_O,znak);
  Write_Comm(hCommDev, Buffer_O, 1);
  delay();
  delay();
  delay();
  delay();
  delay();
  delay();
  delay();
  delay();
  delay();
  Read_Comm(hCommDev, &Buffer_I[0],&Number_Bytes_Read,sizeof(Buffer_I));
  if (Number_Bytes_Read > 0)
  {
    z_str="";
    for (int i=0; i!=Number_Bytes_Read;i++)
    {
       z_str=z_str+char(Buffer_I[i]);
    }
    Form1->Temp->Caption = z_str;
    Form1->Label2->Caption = "C";

  }
}
//---------------------------------------------------------------------------

